﻿-- Author      : Celess
-- Create Date : 11/8/2008 8:59:19 AM

RT_Export = {

}

function RT_Export:ExportSession( r, eFormat )
	if type(r) ~= "table" then return end

	self._format = eFormat
	self._NL = self._NL or "\n" --(IsWindowsClient() and "\n\r" or "\n")
	self._L = RaidTracker.L
	
	if eFormat == 6 then
		return self:GenerateEQPlus(r)
	elseif eFormat == 5 then
		return self:GenerateCSV(r)
	elseif eFormat == 4 then
		return self:GenerateText(r)
	elseif eFormat == 3 then
		return self:GenerateEQdkpStrictXML(r)
	elseif eFormat == 2 then
		return self:GenerateMLdkpXML(r)
	elseif eFormat == 1 or eFormat == 0 then 
		return self:GenerateDkpXML(r)
	end
end

-- helper functions
function RT_Export:GetTS( v, t, k )
	t = t or type(v)
	if not v then				v = ""
	elseif t == "number" then	local f = self._format; v = (f == 0 or (f >= 4 and f <= 5)) and RaidTracker:GetDisplayDate(v) or v;
	elseif t == "itemid" then	v = select(3,v:find("(%d+):%d+"))
	elseif t == "idiff" then	v = _G["DUNGEON_DIFFICULTY"..v]
	elseif t == "xmlpair" then	v = "<"..k..">"..self:GetTS(v) .. "</" .. k .. ">"
	elseif t == "quote" then	v = "\"" .. v .. "\""
	end
	return v
end

function RT_Export:GetInstXML( t )
	local s = ""
	s = s .. "<instance>"
	if t.zone then		s = s .. "<name>" .. t.zone .. "</name>" end
	if t.iid then		s = s .. "<id>" .. t.iid .. "</id>" end
	if t.itype then		s = s .. "<type>" .. t.itype .. "</type>" end
	if t.ireset then	s = s .. "<reset>" .. t.ireset .. "</reset>" end
	if t.idiff then		s = s .. "<difficulty>" .. t.idiff .. "</difficulty>" end
	s = s .. "</instance>"
	return s
end

function RT_Export:GenerateMLdkpXML( r )
	local rt,eFormat = RaidTracker,self._format
	local o = rt._options
	
	local eFormat = self._format
	local race, class, level, sex

	local s ='<?xml version="1.0"?>'
	s = s..'<!DOCTYPE ML_Raidtracker PUBLIC "-//MLdkp//DTD ML_Raidtracker V 1.5//EN" "http://www.mldkp.net/dtds/1.0/ML_Raidtracker.dtd">'

	s = s.."<raidinfo>"
	s = s.."<version>1.5</version>"

	s = s.."<start>"..self:GetTS(r.key).."</start>"
	s = s.."<end>"..self:GetTS(r.End).."</end>"

	if r.realm then
		s = s.."<realm>"..r.realm.."</realm>"
	end

	if r.zone then
		s = s.."<zone>"..r.zone.."</zone>"
	end
	if r.iid then
		s = s.."<instanceid>"..r.iid.."</instanceid>"
	end
	s = s .. self:GetInstXML(r)
	s = s.."<exporter>"..UnitName("Player").."</exporter>"

	if r.Players then
		s = s.."<playerinfos>"
		for k, v in pairs(r.Players) do
			s = s.."<player>"
			s = s.."<name>"..k.."</name>"
			for k2, v2 in pairs(r.Players[k]) do
				if k2 == "note" then
					s = s.."<"..k2.."><![CDATA["..v2.."]]></"..k2..">"
				elseif k2 == "class" then
					s = s.."<"..k2..">"..rt._lookup.ClassToId[v2].."</"..k2..">"
				elseif k2 == "race" then
					s = s.."<"..k2..">"..rt._lookup.RaceToId[v2].."</"..k2..">"
				elseif k2 == "level" then
					if o.LevelMax < v2 then
						s = s.."<"..k2..">"..v2.."</"..k2..">"
					end
				else
					s = s.."<"..k2..">"..v2.."</"..k2..">"
				end
			end
			s = s.."</player>"
		end
		s = s.."</playerinfos>"
	end
	if r.Events then
		local bosskillsindex = 1
		s = s.."<bosskills>"
		for k, v in pairs(r.Events) do
			s = s.."<bosskill>"
			s = s.."<name>"..v.boss.."</name>"
			s = s.."<time>"..self:GetTS(v.time).."</time>"
			s = s .. self:GetInstXML( v )
			s = s.."</bosskill>"
		end
		s = s.."</bosskills>"
	end
	if r.Wipes then
		s = s.."<wipes>"
		for k, v in pairs(r.Wipes) do
			s = s.."<wipe><time>"..v.."</time></wipe>"
		end
		s = s.."</wipes>"
	end
	if r.bossnext then
		s = s.."<nextboss>"..r.bossnext.."</nextboss>"
	end

	if r.note then
		s = s.."<note><![CDATA["..r.note.."]]></note>"
	end

	s = s.."<joins>"
	for k, v in pairs(r.Join) do
		s = s.."<join>"
		s = s.."<player>"..v.player.."</player>"
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		s = s.."</join>"
	end
	s = s.."</joins>"
	s = s.."<leaves>"
	for k, v in pairs(r.Leave) do
		s = s.."<leave>"
		s = s.."<player>"..v.player.."</player>"
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		s = s.."</leave>"
	end
	s = s.."</leaves>"
	s = s.."<loots>"

	for k, v in pairs(r.Loot) do
		s = s.."<loot>"
		s = s.."<itemname>"..v.item.name.."</itemname>"
		s = s.."<itemid>"..v.item.id.."</itemid>"
		s = s.."<count>"..(v.item.count or 1).."</count>"
		s = s.."<player>"..v.player.."</player>"
		if v.cost then
			s = s.."<costs>"..v.cost.."</costs>"
		end
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		if v.zone then
			s = s.."<zone>"..v.zone.."</zone>"
		end
		if v.boss then
			s = s.."<boss>"..v.boss.."</boss>"
		end
		if v.note then
			s = s.."<note><![CDATA["..v.note.."]]></note>"
		end
		s = s.."</loot>"
	end
	s = s.."</loots>"
	s = s.."</raidinfo>"

	return s
end


function RT_Export:GenerateDkpXML( r )
	local eFormat = self._format

	local s = "<RaidInfo>"
	if eFormat == 0 then
--		s = s.."<Version>1.4</Version>"
	end

	if eFormat == 0 then
		s = s.."<key>"..self:GetTS(r.key).."</key>"
	end
	s = s.."<start>"..self:GetTS(r.key).."</start>"
	if r.End then
		s = s.."<end>"..self:GetTS(r.End).."</end>"
	end
	if r.zone then
		s = s.."<zone>"..r.zone.."</zone>"
	end

	if r.iid then
		s = s.."<instanceid>"..r.iid.."</instanceid>"
	end
	s = s .. self:GetInstXML( r )

	if r.Players then
		s = s.."<PlayerInfos>"
		local idx = 1
		for k, v in pairs(r.Players) do
			s = s.."<key"..idx..">"
			s = s.."<name>"..k.."</name>"
			for k2, v2 in pairs(r.Players[k]) do
				if k2 == "note" then
					s = s.."<"..k2.."><![CDATA["..v2.."]]></"..k2..">"

				else
					s = s.."<"..k2..">"..v2.."</"..k2..">"
				end
			end
			s = s.."</key"..idx..">"
			idx = idx + 1
		end
		s = s.."</PlayerInfos>"
	end
	if r.Events then
		local i = 1
		s = s.."<BossKills>"
		for k, v in pairs(r.Events) do
			s = s.."<key"..i..">"
			s = s.."<name>"..v.boss.."</name>"
			s = s.."<time>"..self:GetTS(v.time).."</time>"
			s = s .. self:GetInstXML( v )
			if eFormat == 0 then
				if  v.attendees then
					s = s.."<attendees>"
					for k2, v2 in pairs(v.attendees) do
						s = s.."<key"..k2..">"
						s = s.."<name>"..v2.."</name>"
						s = s.."</key"..k2..">"
					end
					s = s.."</attendees>"
				end
			end
			s = s.."</key"..i..">"
			i = i + 1
		end
		s = s.."</BossKills>"
	end
	-- new exports
	if r.Wipes then
		s = s.."<Wipes>"
		for k, v in pairs(r.Wipes) do
			s = s.."<Wipe>"..v.."</Wipe>"
		end
		s = s.."</Wipes>"
	end
	if r.bossnext then
		s = s.."<NextBoss>"..r.bossnext.."</NextBoss>"
	end
	--
	if eFormat == 0 then
		local sNote = "<note><![CDATA["
		if r.note then sNote = sNote..r.note; end
		if r.zone then sNote = sNote.." - Zone: "..r.zone; end
		sNote = sNote.."]]></note>"
		s = s..sNote
	else
		if r.note then s = s.."<note><![CDATA["..r.note.."]]></note>"; end
	end
	s = s.."<Join>"
	for k, v in pairs(r.Join) do
		s = s.."<key"..k..">"
		s = s.."<player>"..v.player.."</player>"
		if eFormat == 0 and r.Players and r.Players[v.player] then
			local v = r.Players[v.player]
			if v.race then s = s.."<race>"..v.race.."</race>" end
			if v.class then s = s.."<class>"..v.class.."</class>" end
			if v.sex then s = s.."<sex>"..v.sex.."</sex>" end
			if v.level then s = s.."<level>"..v.level.."</level>" end
			if v.note then s = s.."<note><![CDATA["..v.note.."]]></note>" end
		end
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		s = s.."</key"..k..">"
	end
	s = s.."</Join>"
	s = s.."<Leave>"
	for k, v in pairs(r.Leave) do
		s = s.."<key"..k..">"
		s = s.."<player>"..v.player.."</player>"
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		s = s.."</key"..k..">"
	end
	s = s.."</Leave>"
	s = s.."<Loot>"
	for k, v in pairs(r.Loot) do
		s = s.."<key"..k..">"
		s = s.."<ItemName>"..v.item.name.."</ItemName>"
		s = s.."<ItemID>"..v.item.id.."</ItemID>"
		if v.item.icon then s = s.."<Icon>"..v.item.icon.."</Icon>" end
		if v.item.class then s = s.."<Class>"..v.item.class.."</Class>"; end
		if v.item.subclass then s = s.."<SubClass>"..v.item.subclass.."</SubClass>"; end
		s = s.."<Color>"..v.item.c.."</Color>"
		s = s.."<Count>"..(v.item.count or 1).."</Count>"
		s = s.."<Player>"..v.player.."</Player>"
		if v.cost then
			s = s.."<Costs>"..v.cost.."</Costs>"
		end
		s = s.."<Time>"..self:GetTS(v.time).."</Time>"
		if v.zone then s = s.."<Zone>"..v.zone.."</Zone>"; end
		if v.boss then s = s.."<Boss>"..v.boss.."</Boss>"; end
		if eFormat == 0 then
			local sNote = "<Note><![CDATA["
			if v.note then sNote = sNote..v.note; end
			if v.zone then sNote = sNote.." - Zone: "..v.zone; end
			if v.boss then sNote = sNote.." - Boss: "..v.boss; end
			if v.cost then sNote = sNote.." - "..v.cost.." DKP"; end
			sNote = sNote.."]]></Note>"
			s = s..sNote
		else
			if v.note then s = s.."<Note><![CDATA["..v.note.."]]></Note>"; end
		end
		s = s.."</key"..k..">"
	end
	s = s.."</Loot>"
	s = s.."</RaidInfo>"

	return s
end


function RT_Export:GenerateEQdkpStrictXML( r )
	local o = RaidTracker._options
	local eFormat = self._format

	local s,c = "<RaidInfo>"

	s = s.."<key>"..self:GetTS(r.key).."</key>"
	s = s.."<start>"..self:GetTS(r.key).."</start>"
	if r.End then s = s.."<end>"..self:GetTS(r.End).."</end>" end
	s = s.."<zone>"..(r.zone or "").."</zone>"

	s = s.."<PlayerInfos>"
	local i = 1
	for k, v in pairs(r.Players) do
		s = s.."<key"..i..">"
		s = s.."<name>"..k.."</name>"
		for k1, v1 in pairs(v) do
			if k1 == "note" then v1 = "<![CDATA["..v1.."]]>" end				
			s = s.."<"..k1..">"..v1.."</"..k1..">"
		end
		s = s.."</key"..i..">"
		i = i + 1
	end
	s = s.."</PlayerInfos>"
	
	s = s.."<BossKills>"
	for i, v in pairs(r.Events) do
		s = s.."<key"..i..">"
		s = s.."<name>"..v.boss.."</name>"
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		s = s.."<attendees>"
		if v.attendees then
			for i1, v1 in pairs(v.attendees) do
				s = s.."<key"..i1..">" .. "<name>"..v1.."</name>" .. "</key"..i1..">"
			end
		end
		s = s.."</attendees>"
		s = s.."</key"..i..">"
	end
	s = s.."</BossKills>"
	
	s = s.."<note>"
	if r.note or r.zone then
		s = s .. "<![CDATA["
		if r.note then s = s..r.note end
		if r.zone then s = s.." - Zone: "..r.zone end
		s = s .. "]]>"
	end
	s = s.."</note>"

	s = s.."<Join>"
	for i,v in pairs(r.Join) do
		s = s.."<key"..i..">"
		s = s.."<player>"..v.player.."</player>"
		if r.Players and r.Players[v.player] then
			local v = r.Players[v.player]
			if v.race then s = s.."<race>"..v.race.."</race>" end
			if v.class then s = s.."<class>"..v.class.."</class>" end
			if v.sex then s = s.."<sex>"..v.sex.."</sex>" end
			s = s.."<level>".. ((v.level and v.level>0) and v.level or o.LevelMax) .."</level>"
			if v.note then s = s.."<note><![CDATA["..v.note.."]]></note>" end
		end
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		s = s.."</key"..i..">"
	end
	s = s.."</Join>"

	s = s.."<Leave>"
	for i, v in pairs(r.Leave) do
		s = s.."<key"..i..">"
		s = s.."<player>"..v.player.."</player>"
		s = s.."<time>"..self:GetTS(v.time).."</time>"
		s = s.."</key"..i..">"
	end
	s = s.."</Leave>"

	s = s.."<Loot>"
	for k, v in pairs(r.Loot) do
		c = v.item
		s = s.."<key"..k..">"
		s = s.."<ItemName>"..c.name.."</ItemName>"
		s = s.."<ItemID>"..c.id.."</ItemID>"
		if c.icon then s = s.."<Icon>"..c.icon.."</Icon>" end
		if c.class then s = s.."<Class>"..c.class.."</Class>" end
		if c.subclass then s = s.."<SubClass>"..c.subclass.."</SubClass>" end
		if c.c then s = s.."<Color>"..c.c.."</Color>" end
		s = s.."<Count>"..(c.count or 1).."</Count>"
		s = s.."<Player>"..v.player.."</Player>"
		if v.cost then	s = s.."<Costs>"..v.cost.."</Costs>" end
		s = s.."<Time>"..self:GetTS(v.time).."</Time>"
		if v.zone then s = s.."<Zone>"..v.zone.."</Zone>" end
		if v.boss then s = s.."<Boss>"..v.boss.."</Boss>" end
		s = s.."<Note><![CDATA["
		if v.note then s = s..v.note end
		if v.zone then s = s.." - Zone: "..v.zone end
		if v.boss then s = s.." - Boss: "..v.boss end
		if v.cost then s = s.." - "..v.cost.." DKP" end
		s = s.."]]></Note>"
		s = s.."</key"..k..">"
	end
	s = s.."</Loot>"
	
	s = s.."</RaidInfo>"
	
	return s
end


function RT_Export:GenerateText( r )
	local L,NL,eFormat = self._L,self._NL,self._format
	local s = ""

	function ts( v, t )
		t = t or type(v); if t == "string" then v = v or L["Unknown"] end
		return self:GetTS( v, t )
	end
	
	s = s .. ts(L[r.zone]) .. (r.idiff and " " or "") .. ts(r.idiff,"idiff") .. " " .. ts(r.key) .. " - " .. ts(r.End)
	s = s .. ts(r.note,"quote") .. NL .. NL
	
	s = s .. L["Players"] .. ":" .. NL
	local t = { }; for k,v in pairs(r.Players) do tinsert(t,{k,v}) end; table.sort(t, function(a,b) return a[1] < b[1] end)
	for i,v in pairs(t) do
		local join,leave,v1 = nil,nil,v[2]
		for i1,v1 in pairs(r.Join) do if v[1] == v1.player then join = v1.time; break end end
		for i1,v1 in pairs(r.Leave) do if v[1] == v1.player then leave = v1.time end end
		s = s .. i .. " " .. (v[1] or "Unknown") .. " ".. (join and self:GetTS(join) or "") .. " - " .. (leave and self:GetTS(leave) or "")
		for k1,v1 in pairs(v[2]) do
			if k1 ~= "sex" then
				s = s .. ", " .. ((k1 == "note" and v1) and ("\""..v1.."\"") or L[v1])
			end
		end
		s = s .. NL
	end
	s = s .. NL

	s = s .. L["Events"] .. ":" .. NL
	for i,v in pairs(r.Events) do
		s = s .. i .. " " .. L[v.boss or "Unknown"] .. " in " .. L[v.zone or r.zone or "Unknown"]
		s = s .. ((v.idiff or r.idiff) and (" " .. _G["DUNGEON_DIFFICULTY"..(v.idiff or r.idiff)]) or "") .. " at " .. self:GetTS(v.time)
		if v.attendees then
			for i1,v1 in pairs(v.attendees) do
				s = s .. (((i1 % 10) == 0 or i1 == 1) and (NL.."    ") or ", ") .. v1
			end
		end
		s = s .. NL
	end
	s = s .. NL

	s = s .. L["Loot"] .. ":" .. NL
	for i,v in pairs(r.Loot) do	
		s = s .. i .. " " .. (v.item.name or "Unknown") .. " (" .. (v.item.id and select(3,v.item.id:find("(%d+):%d+")) or "Unknown") .. ")"
		s = s .. " at " .. self:GetTS(v.time) .. " from " .. L[v.boss or "Unknown"] .. " to " .. (v.player or "Unknown") .. " (Cost: " .. (v.cost or 0) .. ") "
		if v.note then s = s .. (NL.."    ") .. (v.note and ("\"" .. v.note .. "\"") or "") end
		s = s .. NL
	end
	s = s .. NL

	return s
end

function RT_Export:GenerateCSV( r )
	local L,NL,eFormat = self._L,self._NL,self._format
	local s = ""
	
	function ts( v, t )
		t = t or type(v); if t == "string" then t = "quote" end
		return self:GetTS( v, t )
	end
	
	s = s .. L["Session"] .. ":" .. NL
	s = s .. "Zone,Difficulty,Start,End,Note" .. NL
	s = s .. ts(r.zone) .. "," .. ts(r.idiff,"idiff") .. "," .. ts(r.key) .. "," .. ts(r.End) .. "," .. ts(r.note) .. NL
	s = s .. NL
	
	s = s .. L["Players"] .. ":" .. NL
	s = s .. "Index,Name,Join,Leave,Race,Class,Level,Guild,Note" .. NL
	local t = { }; for k,v in pairs(r.Players) do tinsert(t,{k,v}) end; table.sort(t, function(a,b) return a[1] < b[1] end)
	for i,v in pairs(t) do
		local join,leave,v1 = nil,nil,v[2]
		for i1,v1 in pairs(r.Join) do if v[1] == v1.player then join = v1.time; break end end
		for i1,v1 in pairs(r.Leave) do if v[1] == v1.player then leave = v1.time end end
		s = s .. i .. "," .. ts(v[1]) .. ",".. ts(join) .. "," .. ts(leave) .. "," .. ts(v1.race) .. ","
		s = s .. ts(v1.class) .. "," .. ts(v1.level,"L") .. "," .. ts(v1.guild) .. "," .. ts(v1.note)
		s = s .. NL
	end
	s = s .. NL

	s = s .. L["Events"] .. ":" .. NL
	s = s .. "Index,Name,Zone,Difficulty,End,Attendees" .. NL
	for i,v in pairs(r.Events) do
		s = s .. i .. "," .. ts(v.boss) .. "," .. ts(v.zone or r.zone) .. "," .. ts((v.idiff or r.idiff),"idiff") .. "," .. ts(v.time) .. ","
		if v.attendees then
			local a = ""; for i1,v1 in pairs(v.attendees) do a = a .. (i1 ~= 1 and ";" or "") .. v1 end; s = s .. ts(a)
		end
		s = s .. NL
	end
	s = s .. NL

	s = s .. L["Loot"] .. ":" .. NL
	s = s .. "Index,Name,ID,Time,Mob,Player,Cost,Note" .. NL
	for i,v in pairs(r.Loot) do	
		s = s .. i .. "," .. ts(v.item.name) .. "," .. ts(v.item.id,"itemid") .. "," .. ts(v.time) .. "," 
		s = s .. ts(v.boss) .. "," .. ts(v.player) .. "," .. ts(v.cost or 0,"L") .. "," .. ts(v.note)
		s = s .. NL
	end
	s = s .. NL

	return s
end

function RT_Export:ProcessEqDKPTimes( r ) -- author paschy
	local t = { }

	for k,v in pairs( r.Join ) do
		if not t[v.player] then	t[v.player] = { } end
		table.insert( t[v.player], { self:GetTS(v.time), "join" } )
	end
	for k,v in pairs( r.Leave ) do
		if not t[v.player] then	t[v.player] = { } end
		table.insert( t[v["player"]], { self:GetTS(v.time), "leave" } )
	end
	for k,v in pairs( t ) do
		table.sort( t[k], function (a,b) return (a[1] < b[1]) end )
	end
	
	local oldval, oldkey = 0, 0
	for k,v in pairs( t ) do
		local toDelete = { }
		for k1,v1 in pairs( t[k] ) do
			if v1[1] == oldval then
				table.insert( toDelete, k1 )
				table.insert( toDelete, oldkey )
			end
			oldval = v1[1]
			oldkey = k1
		end
		for k1,v1 in pairs( toDelete ) do table.remove( t[k], v1 ) end
	end

	return t	
end

function RT_Export:GenerateEQPlus( r )
	local L,NL,eFormat = self._L,self._NL,self._format
	local s = ""

	s = '<raidlog>';
	s = s.."<head>";
	s = s.."<export><name>EQdkp Plus XML</name><version>1.0</version></export>"
	s = s.."<tracker><name>Raid Tracker</name><version>2.2.27</version></tracker>"
	s = s.."<gameinfo><game>World of Warcraft</game><language>"..GetLocale().."</language><charactername>"..UnitName("Player").."</charactername></gameinfo>"
	s = s.."</head>"
	
	s = s.."<raiddata>"
	s = s.."<zones><zone>"
	s = s.."<enter>"..self:GetTS(r.key).."</enter>"
	s = s.."<leave>"..self:GetTS(r.End).."</leave>"
	if r.zone then s = s.."<name>"..r.zone.."</name>" end
	if r.idiff then s = s.."<difficulty>"..r.idiff.."</difficulty>" end
	s = s.."</zone></zones>"
	
	s = s.."<bosskills>"	
	if r.Events then
		for k, v in pairs(r.Events) do
			s = s.."<bosskill>"
			s = s.."<name>"..v.boss.."</name>"
			s = s.."<time>"..self:GetTS(v.time).."</time>"
			s = s.."</bosskill>"
		end
	end
    s = s.."</bosskills>"

    s = s.."<members>"
	local times = self:ProcessEqDKPTimes( r )
	for k, v in pairs( times ) do
    	s = s.."<member>"
    	s = s.."<name>"..k.."</name>"
    	if r.Players[k] then
    		for k2,v2 in pairs( r.Players[k] ) do
    			if k2 == "note" then
    				s = s.."<note><![CDATA["..v2.."]]></note>"
    			elseif k2 == "class" then
    				s = s.."<class>"..v2.."</class>"
    			elseif k2 == "race" then
    				s = s.."<race>"..v2.."</race>"
    			elseif k2 == "level" then
    				s = s.."<level>"..v2.."</level>"
    			else
    				s = s.."<"..k2..">"..v2.."</"..k2..">"
    			end
    		end
    	end
    	s = s.."<times>"
    	for k2,v2 in pairs( v ) do
    		s = s.."<time type='"..v2[2].."'>"..v2[1].."</time>"
    	end
    	s = s.."</times>"
    	s = s.."</member>"
    end
    s = s.."</members>"

    s = s.."<items>"
	for k, v in pairs( r.Loot ) do
		s = s.."<item>"
		s = s.."<name>"..v.item.name.."</name>"
        s = s.."<time>"..self:GetTS(v.time).."</time>"
        s = s.."<member>"..v.player.."</member>"
		s = s.."<itemid>"..v.item.id.."</itemid>"
		if v.cost then	s = s.."<cost>"..v.cost.."</cost>"	end
		s = s.."</item>"
	end
	s = s.."</items>"

	s = s.."</raiddata>"
	s = s.."</raidlog>"
	
	return s
end

